博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
Codeforces Round #256 (Div. 2) C. Painting Fence 或搜索DP
阅读量:6919 次
发布时间:2019-06-27

本文共 3394 字,大约阅读时间需要 11 分钟。

C. Painting Fence
time limit per test
1 second
memory limit per test
512 megabytes
input
standard input
output
standard output

Bizon the Champion isn't just attentive, he also is very hardworking.

Bizon the Champion decided to paint his old fence his favorite color, orange. The fence is represented as n vertical planks, put in a row. Adjacent planks have no gap between them. The planks are numbered from the left to the right starting from one, the i-th plank has the width of 1 meter and the height of ai meters.

Bizon the Champion bought a brush in the shop, the brush's width is 1 meter. He can make vertical and horizontal strokes with the brush. During a stroke the brush's full surface must touch the fence at all the time (see the samples for the better understanding). What minimum number of strokes should Bizon the Champion do to fully paint the fence? Note that you are allowed to paint the same area of the fence multiple times.

Input

The first line contains integer n (1 ≤ n ≤ 5000) — the number of fence planks. The second line contains n space-separated integersa1, a2, ..., an (1 ≤ ai ≤ 109).

Output

Print a single integer — the minimum number of strokes needed to paint the whole fence.

Sample test(s)
input
52 2 1 2 1
output
3
input
22 2
output
2
input
15
output
1
Note

In the first sample you need to paint the fence in three strokes with the brush: the first stroke goes on height 1 horizontally along all the planks. The second stroke goes on height 2 horizontally and paints the first and second planks and the third stroke (it can be horizontal and vertical) finishes painting the fourth plank.

In the second sample you can paint the fence with two strokes, either two horizontal or two vertical strokes.

In the third sample there is only one plank that can be painted using a single vertical stroke.

题意:你面前有宽度为1,高度给定的连续木板,每次能够刷一横排或一竖列,问你至少须要刷几次。

解题方法一:DP

思路:这题刚開始看题的时候知道,不是取n,就是取当中最短的然后横着刷。然后再取最短的再横着刷,再和坚着刷比較哪个更小。可是知道了不知道该怎样下手。然后发现别人是动态规划做的。看了好久的状态方程才有点理解。

dp[i][j]表示第i列以后的木板都刷完了且前面的第j列是横着刷的。最少须要的次数。

#include
#include
#include
#include
#include
#include
#include
#include
#include
#define mem(a,b) memset(a,b,sizeof(a))#define INF 1000000070000using namespace std;typedef long long ll;typedef unsigned long long ull;int value[5010],dp[5010][5010];int main(){ int n,i,j,k; scanf("%d",&n); value[0]=0; for(i=1; i<=n; i++) scanf("%d",&value[i]); for(i=0; i<=n; i++) dp[n][i]=0; for(i=n; i>=1; i--) for(j=0; j
=value[i]) dp[i-1][j]=dp[i][i]; else dp[i-1][j]=min(dp[i][j]+1,dp[i][i]+value[i]-value[j]); //cout<
<<' '<
<<' '<
<
解题方法二:搜索

思路:假设是竖着刷,应当是篱笆的条数,横着刷的话,就是刷完最短木板的长度,再接着考虑没有刷的木板中最短的。然后再和坚着刷比較。

这样能够用搜索来找每次最短的。

#include
#include
#include
#include
#include
#include
#include
#include
#include
#define mem(a,b) memset(a,b,sizeof(a))#define INF 100000007using namespace std;typedef long long ll;typedef unsigned long long ull;int a[5005];int dfs(int l,int r){ int i,ll,num=0,Min=INF; for(i=l;i<=r;i++) Min=min(Min,a[i]); for(i=l;i<=r;i++) a[i]-=Min; num+=Min; for(i=l,ll=l;i<=r;i++) if(!a[i]) num+=dfs(ll,i-1),ll=i+1; if(ll<=r) num+=dfs(ll,r); return min(num,r-l+1);}int main(){ int n,i; cin>>n; for(i=1;i<=n;i++) scanf("%d",a+i); cout<
<

版权声明:本文博客原创文章,博客,未经同意,不得转载。

你可能感兴趣的文章
sed对文本内容进行添加和删除
查看>>
Zookeeper初遇
查看>>
关于windows 双网卡和跃点数研究
查看>>
Android 建立文件夹、生成文件并写入文本文件内容
查看>>
三大特性与数据类型
查看>>
Linux安装配置***服务器
查看>>
hibernate4之 配置(一)
查看>>
安装grub的两种方法
查看>>
Centos6.5源码搭建SVN+Apache
查看>>
动态规划求组合系数
查看>>
SpringFramework之Servlet的request path
查看>>
filebeat导入Hadoop日志到Elasticsearch中
查看>>
LAMP平台部署及应用(2)——部署phpMyAdmin系统
查看>>
centos 开机启动服务设置
查看>>
HashMap源码分析
查看>>
$.ajax()方法详解
查看>>
Lync 2010与2013共存无法共享PPT白板功能
查看>>
程序员十大撩妹技能
查看>>
keepalived体系结构及相关配置
查看>>
Linux小技巧一:通过文件内的关键字来查找文件
查看>>